-- CreaDMG.applescript
-- CreaDMG

--  Created by hany on 01/09/05.
--  Copyright 2005 hanynet.com. All rights reserved.

-- CreaDMG is a cocoa-applescript application for MacOSX 10.3> (ppc and intel and even MIPS and sparc if possible ;) )
-- CreaDMG allows you to create compressed multi-platform password-protected disk images of selected volumes, files or directories.

-- inizializza proprieta' pannelli
property panelWIndow : missing value
property progressPanel : missing value
property helpPanel : missing value
property reportPanel : missing value
property createMode : missing value

on chooseSource()
	-- Setup the open panel properties
	tell open panel
		set can choose directories to true
		set can choose files to true
		set allows multiple selection to false
		set prompt to "OK"
	end tell
	display open panel
end chooseSource

on chooseDest()
	-- Setup the save panel properties
	tell save panel
		set prompt to "OK"
	end tell
	display save panel
end chooseDest


on eseguiBackup()
	-- esegui solo se i campi non sono vuoti
	if the contents of text field "sourcedir" of window "main" is not equal to "" then
		if the contents of text field "destfile" of window "main" is not equal to "" then
			-- setta variabili di opzioni come default
			
			set theCrypt to "false" as boolean
			set unRead to "false" as boolean
			
			-- prendi variabili da opzioni se e' gia' stato aperto
			if panelWIndow is not equal to missing value then
				set selectedRow to current row of matrix "type" of window "opzioni"
				set theCrypt to the contents of button "crypt" of window "opzioni" as boolean
				set theCompression to current row of matrix "comp" of window "opzioni"
				set unRead to the contents of button "unread" of window "opzioni" as boolean
			else
				-- se il pannello opzioni non e' ancora stato aperto, setta la variabile a 1
				-- che corrisponde alla prima riga della matrice, quella di default.
				set selectedRow to "1" as number
				-- definisci formato file e estensione di default
				set dmgFormat to "UDRW"
				set theDestExt to ".dmg"
				-- imposta come default 'nessuna compressione'
				set theCompression to "1" as number
				
			end if
			-- carica progress panel solo la prima volta
			if progressPanel is missing value then
				load nib "ProgressPanel"
				set progressPanel to window "progress"
			end if
			-- display progress panel
			display progressPanel attached to window "main"
			tell progressPanel
				set uses threaded animation of progress indicator "progress" to true
				tell progress indicator "progress" to start
			end tell
			
			-- definisci variabili per i path di hdiutil
			set theSource to the contents of text field "sourcedir" of window "main"
			set theDest to the contents of text field "destfile" of window "main"
			-- opzione crypt
			if theCrypt is equal to "true" as boolean then
				set cryptOption to "-encryption "
			else
				set cryptOption to ""
			end if
			if unRead is equal to "true" as boolean then
				set skipUnreadable to " -skipunreadable "
			else
				set skipUnreadable to ""
			end if
			-- opzione formato
			if selectedRow is equal to "1" as number then
				set dmgFormat to "UDRW"
				set theDestExt to ".dmg"
				set createMode to "0"
			end if
			if selectedRow is equal to "2" as number then
				set dmgFormat to "UDRO"
				set theDestExt to ".dmg"
				set createMode to "0"
			end if
			if selectedRow is equal to "3" as number then
				set dmgFormat to "UDZO"
				set theDestExt to ".dmg"
				set createMode to "0"
			end if
			if selectedRow is equal to "4" as number then
				set dmgFormat to "UDBZ"
				set theDestExt to ".dmg"
				set createMode to "0"
			end if
			if selectedRow is equal to "5" as number then
				set dmgFormat to "UDTO"
				set theDestExt to ".cdr"
				set createMode to "0"
			end if
			if selectedRow is equal to "6" as number then
				set dmgFormat to "UDSP"
				set theDestExt to ".sparseimage"
				set createMode to "1"
			end if
			
			-- setta nome del volume virtuale associato al file creato
			set theVolume to the contents of text field "volumename" of window "main" as string
			if theVolume is equal to "" then
				set theVolume to "Archive" as string
			end if
			-- UDSP ONLY
			if createMode = "1" then
				set the contents of text field "busytxt" of window "progress" to "UDSP Image"
				-- shell script per sparseimage
				-- crea sparseimage
				set dmgOut to do shell script ("hdiutil create -ov -verbose -fs HFS+ " & cryptOption & " -type SPARSE -autostretch " & skipUnreadable & " -volname " & the quoted form of theVolume & " " & the quoted form of (theDest & theDestExt))
				-- monta sparseimage
				do shell script "hdiutil mount " & the quoted form of (theDest & theDestExt)
				-- copia files
				set the contents of text field "busytxt" of window "progress" to "Copying..."
				do shell script "sleep 1; cp -Rp \"" & theSource & "\" \"/Volumes/" & theVolume & "\""
				-- smonta sparseimage
				set the contents of text field "busytxt" of window "progress" to "Unmounting..."
				do shell script "sleep 1; hdiutil eject \"/Volumes/" & theVolume & "\""
				
				-- OTHER FORMATS
			else
				-- shell script hdiutil per tutti gli altri formati
				set dmgOut to do shell script ("hdiutil create -ov -verbose " & cryptOption & " -format " & dmgFormat & skipUnreadable & " -volname " & the quoted form of theVolume & " -srcdir " & the quoted form of theSource & " " & the quoted form of (theDest & theDestExt))
			end if
			-- opzioni di compressione
			if theCompression is equal to "2" as number then
				set out to do shell script "sleep 3; gzip " & the quoted form of theDest & theDestExt
			end if
			if theCompression is equal to "3" as number then
				do shell script "tar cf " & the quoted form of theDest & ".tar " & " " & the quoted form of theDest & theDestExt
				do shell script " rm -f " & the quoted form of theDest & theDestExt
			end if
			if theCompression is equal to "4" as number then
				do shell script "zip " & the quoted form of theDest & " " & the quoted form of theDest & theDestExt
				do shell script " rm -f " & the quoted form of theDest & theDestExt
			end if
			
			-- close progress panel
			tell progress indicator "progress" of progressPanel to stop
			close panel progressPanel
			
			-- report panel
			-- carica reportPanel la prima volta
			if reportPanel is missing value then
				load nib "ReportPanel"
				set reportPanel to window "report"
			end if
			set the contents of text view "insp" of scroll view "insp" of window "report" to dmgOut
			display reportPanel attached to window "main"
		end if
	end if
end eseguiBackup


on clicked theObject
	-- Event handler quando si clicca un pulsante
	if the name of theObject is equal to "optionspanel" then
		-- carica opzioni solo una volta
		if panelWIndow is equal to missing value then
			load nib "options"
			set panelWIndow to window "opzioni"
		end if
		-- mostra panel opzioni
		display panelWIndow attached to window "main"
	end if
	
	-- azioni sui pulsanti
	-- pulsante SCEGLI SORGENTE
	if the name of theObject is equal to "choosesource" then
		set the contents of text field "stdoutbox" of window "main" to ""
		set the contents of text field "sourcedir" of window "main" to ""
		chooseSource()
		set the contents of text field "sourcedir" of window "main" to path name of open panel
	end if
	-- pulsante SCEGLI DESTINAZIONE
	if the name of theObject is equal to "choosedest" then
		set the contents of text field "stdoutbox" of window "main" to ""
		set the contents of text field "destfile" of window "main" to ""
		chooseDest()
		set the contents of text field "destfile" of window "main" to path name of save panel
	end if
	-- pulsante BACKUP
	if the name of theObject is equal to "startbackup" then
		set the contents of text field "stdoutbox" of window "main" to ""
		eseguiBackup()
	end if
	-- pulsante HELP
	if the name of theObject is equal to "help" then
		if helpPanel is equal to missing value then
			load nib "HelpPanel"
			set helpPanel to window "help"
		end if
		display helpPanel attached to window "main"
	end if
	-- pulsante ESCI
	if the name of theObject is equal to "quit" then
		quit
	end if
end clicked

on should quit after last window closed theObject
	quit
end should quit after last window closed

on choose menu item theObject
	if the name of theObject is equal to "aboutmenu" then
		display window "about" (*attached to window "main"*)
		set enabled of theObject to true as boolean
	end if
end choose menu item


-- eof












